## dotnet7 7.0.110

=== src/runtime/src/mono/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.5)

if (CMAKE_VERSION VERSION_GREATER 3.15 OR CMAKE_VERSION VERSION_EQUAL 3.15)
  cmake_policy(SET CMP0091 NEW)
endif()

project(mono)

include(../../eng/native/configurepaths.cmake)
include(${CLR_ENG_NATIVE_DIR}/functions.cmake)

if (MSVC)
  # Also set by configurecompiler.cmake, which isn't used by mono yet
  add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/source-charset:utf-8>) # Force MSVC to compile source as UTF-8.
endif(MSVC)

set(CROSS_ROOTFS $ENV{ROOTFS_DIR})
set(CMAKE_C_FLAGS_CHECKED "")
set(CMAKE_CXX_FLAGS_CHECKED "")
set(CMAKE_EXE_LINKER_FLAGS_CHECKED "")
set(CMAKE_SHARED_LINKER_FLAGS_CHECKED "")

if(NOT MONO_LIB_NAME)
  set(MONO_LIB_NAME "monosgen-2.0")
endif()

if(NOT MONO_SHARED_LIB_NAME)
  set(MONO_SHARED_LIB_NAME "${MONO_LIB_NAME}")
endif()

include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckFunctionExists)
include(TestBigEndian)
include(CheckCCompilerFlag)

set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  )
set(CMAKE_INSTALL_MESSAGE LAZY)

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

function(append value)
  foreach(variable ${ARGN})
    set(${variable} "${${variable}} ${value}" PARENT_SCOPE)
  endforeach(variable)
endfunction()

# User options
include(options)

function(process_enable_minimal)
  string(REPLACE "," ";" tmp1 "${ENABLE_MINIMAL}")
  foreach(arg ${tmp1})
    string(TOUPPER "${arg}" var1)
	if("${DISABLE_${var1}}" STREQUAL "")
	  message(FATAL_ERROR "Unknown DISABLE_ option DISABLE_${var1}.")
	endif()
    set(DISABLE_${var1} 1 PARENT_SCOPE)
  endforeach(arg)
endfunction()

if(ENABLE_MINIMAL)
  process_enable_minimal()
endif()

set(DISABLE_COM 1)

# Dependencies between options
if(ENABLE_INTERP_LIB)
  set(DISABLE_INTERPRETER 1)
endif()
if(NOT DISABLE_INTERPRETER OR NOT DISABLE_JIT)
  set(ENABLE_ILGEN 1)
endif()
if(NOT DISABLE_EVENTPIPE)
  set(ENABLE_PERFTRACING 1)
endif()
if(ENABLE_LAZY_GC_THREAD_CREATION)
  set(LAZY_GC_THREAD_CREATION 1)
endif()

set(DISABLED_FEATURES "\"\"")

if((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR(CMAKE_CXX_COMPILER_ID STREQUAL "Clang") OR(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang"))
  set(GCC 1)
endif()

add_definitions(-DHAVE_CONFIG_H)

if(GCC)
  add_definitions(-g)  # TODO: should this really be on by default?
  add_definitions(-fPIC)
  add_definitions(-fvisibility=hidden)
  set(USE_GCC_ATOMIC_OPS 1)
endif()

set(HAVE_CLASSIC_WINAPI_SUPPORT 1)
set(HAVE_MOVING_COLLECTOR 1)
set(HAVE_CONC_GC_AS_DEFAULT 1)
set(MONO_INSIDE_RUNTIME 1)

TEST_BIG_ENDIAN(IS_BIG_ENDIAN)

if(IS_BIG_ENDIAN)
  set(TARGET_BYTE_ORDER G_BIG_ENDIAN)
else()
  set(TARGET_BYTE_ORDER G_LITTLE_ENDIAN)
endif()

######################################
# AOT CROSS COMPILER SUPPORT
######################################

if(NOT AOT_TARGET_TRIPLE STREQUAL "")
  set(MONO_CROSS_COMPILE 1)
  add_definitions(-DNO_GLOBALIZATION_SHIM)
  if(NOT AOT_OFFSETS_FILE STREQUAL "")
    set(MONO_OFFSETS_FILE "${AOT_OFFSETS_FILE}")
  endif()
  if(AOT_TARGET_TRIPLE STREQUAL "x86_64-apple-darwin10")
    set(TARGET_SYSTEM_NAME "iOS")
    set(TARGET_ARCH "x86_64")
  elseif(AOT_TARGET_TRIPLE STREQUAL "i386-apple-darwin10")
    set(TARGET_SYSTEM_NAME "iOS")
    set(TARGET_ARCH "x86")
  elseif(AOT_TARGET_TRIPLE STREQUAL "aarch64-apple-darwin10")
    set(TARGET_SYSTEM_NAME "iOS")
    set(TARGET_ARCH "arm64")
  elseif(AOT_TARGET_TRIPLE STREQUAL "arm-apple-darwin10")
    set(TARGET_SYSTEM_NAME "iOS")
    set(TARGET_ARCH "arm")
  elseif(AOT_TARGET_TRIPLE STREQUAL "x86_64-apple-maccatalyst")
    set(TARGET_SYSTEM_NAME "Darwin")
    set(TARGET_ARCH "x86_64")
    set(TARGET_MACCAT 1)
  elseif(AOT_TARGET_TRIPLE STREQUAL "aarch64-apple-maccatalyst")
    set(TARGET_SYSTEM_NAME "Darwin")
    set(TARGET_ARCH "arm64")
    set(TARGET_MACCAT 1)
  elseif(AOT_TARGET_TRIPLE STREQUAL "wasm32-unknown-none")
    set(TARGET_SYSTEM_NAME "Emscripten")
    set(TARGET_ARCH "wasm")
  elseif(AOT_TARGET_TRIPLE STREQUAL "x86_64-none-linux-android")
    set(TARGET_SYSTEM_NAME "Android")
    set(TARGET_ARCH "x86_64")
  elseif(AOT_TARGET_TRIPLE STREQUAL "i686-none-linux-android")
    set(TARGET_SYSTEM_NAME "Android")
    set(TARGET_ARCH "x86")
  elseif(AOT_TARGET_TRIPLE STREQUAL "aarch64-v8a-linux-android")
    set(TARGET_SYSTEM_NAME "Android")
    set(TARGET_ARCH "arm64")
  elseif(AOT_TARGET_TRIPLE STREQUAL "armv7-none-linux-androideabi")
    set(TARGET_SYSTEM_NAME "Android")
    set(TARGET_ARCH "arm")
  elseif(AOT_TARGET_TRIPLE STREQUAL "aarch64-linux-gnu")
    set(TARGET_SYSTEM_NAME "Linux")
    set(TARGET_ARCH "arm64")
  elseif(AOT_TARGET_TRIPLE STREQUAL "riscv64-linux-gnu")
    set(TARGET_SYSTEM_NAME "Linux")
    set(TARGET_ARCH "riscv64")
  else()
    message(FATAL_ERROR "AOT target '${AOT_TARGET_TRIPLE}' not supported.")
  endif()
endif()

######################################
# HOST OS CHECKS
######################################

message ("CMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}")
message ("CMAKE_SYSTEM_VARIANT=${CMAKE_SYSTEM_VARIANT}")

# TODO: check if we can enable this on more platforms
# set(MONO_KEYWORD_THREAD "__thread")

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  add_definitions(-D_THREAD_SAFE)
  set(HOST_DARWIN 1)
  set(HOST_OSX 1)
  set(PTHREAD_POINTER_ID 1)
  set(USE_MACH_SEMA 1)
  if(CMAKE_SYSTEM_VARIANT STREQUAL "MacCatalyst")
    set(HOST_MACCAT 1)
  endif()
elseif(CMAKE_SYSTEM_NAME STREQUAL "iOS" OR CMAKE_SYSTEM_NAME STREQUAL "tvOS")
  # See man cmake-toolchains(7) on which variables
  # control cross-compiling to ios
  add_definitions(-D_THREAD_SAFE)
  set(HOST_DARWIN 1)
  set(HOST_IOS 1)
  if(CMAKE_SYSTEM_NAME STREQUAL "tvOS")
    set(HOST_TVOS 1)
    # with -fembed-bitcode passing -headerpad_max_install_names is not allowed so remove it from the CMake flags
    string(REPLACE "-Wl,-headerpad_max_install_names" "" CMAKE_C_LINK_FLAGS ${CMAKE_C_LINK_FLAGS})
    string(REPLACE "-Wl,-headerpad_max_install_names" "" CMAKE_CXX_LINK_FLAGS ${CMAKE_CXX_LINK_FLAGS})
    string(REPLACE "-Wl,-headerpad_max_install_names" "" CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS ${CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS})
    string(REPLACE "-Wl,-headerpad_max_install_names" "" CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS ${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS})
    add_compile_options(-fembed-bitcode)
    add_link_options(-fembed-bitcode)
  endif()
  set(PTHREAD_POINTER_ID 1)
  set(USE_MACH_SEMA 1)
  set(DISABLE_EXECUTABLES 1)
  set(TARGET_APPLE_MOBILE 1)
  add_definitions("-DSMALL_CONFIG")
  add_definitions("-D_XOPEN_SOURCE")
  add_definitions("-DHAVE_LARGE_FILE_SUPPORT=1")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(HOST_LINUX 1)
  add_definitions(-D_GNU_SOURCE -D_REENTRANT)
  add_definitions(-D_THREAD_SAFE)
  set(HAVE_CGROUP_SUPPORT 1)
  # Enable the "full RELRO" options (RELRO & BIND_NOW) at link time
  add_link_options(-Wl,-z,relro)
  add_link_options(-Wl,-z,now)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Android")
  set(HOST_LINUX 1)
  add_definitions(-D_GNU_SOURCE -D_REENTRANT)
  add_definitions(-D_THREAD_SAFE)
  add_compile_options(-Wl,-z,now)
  add_compile_options(-Wl,-z,relro)
  add_compile_options(-Wl,-z,noexecstack)
  # The normal check fails because it uses --isystem <ndk root>/sysroot/usr/include
  set(HAVE_USR_INCLUDE_MALLOC_H 1)
  set(HOST_ANDROID 1)
  set(DISABLE_EXECUTABLES 1)
  # Force some defines
  set(HAVE_SCHED_GETAFFINITY 0)
  set(HAVE_SCHED_SETAFFINITY 0)
  # FIXME: Rest of the flags from configure.ac
elseif(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(HOST_BROWSER 1)
  add_definitions(-DNO_GLOBALIZATION_SHIM)
  add_definitions(-D_THREAD_SAFE)
  add_compile_options(-Wno-strict-prototypes)
  add_compile_options(-Wno-unused-but-set-variable)
  set(DISABLE_EXECUTABLES 1)
  # FIXME: Is there a cmake option for this ?
  set(DISABLE_SHARED_LIBS 1)
  # sys/random.h exists, but its not found
  set(HAVE_SYS_RANDOM_H 1)
  set(INTERNAL_ZLIB 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "WASI")
  set(HOST_WASI 1)
  add_definitions(-D_WASI_EMULATED_SIGNAL -D_WASI_EMULATED_MMAN -DHOST_WASI)
  add_definitions(-DNO_GLOBALIZATION_SHIM)
  add_definitions(-D_THREAD_SAFE)
  add_definitions(-DGEN_PINVOKE)
  set(DISABLE_SHARED_LIBS 1)
  set(INTERNAL_ZLIB 1)
  set(DISABLE_EXECUTABLES 1)
  set(STATIC_COMPONENTS 1)

  set(WASI_DRIVER_SOURCES
    wasi/mono-wasi-driver/driver.c
    wasi/mono-wasi-driver/stubs.c
    wasi/mono-wasi-driver/synthetic-pthread.c
  )
  add_library(mono-wasi-driver STATIC ${WASI_DRIVER_SOURCES})
  target_compile_options(mono-wasi-driver PRIVATE -Wno-missing-prototypes -Wno-strict-prototypes)
  install(TARGETS mono-wasi-driver LIBRARY)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(HOST_WIN32 1)
  set(EXE_SUFFIX ".exe")
  set(HOST_NO_SYMLINKS 1)
  set(MONO_KEYWORD_THREAD "__declspec (thread)")
  set(MONO_ZERO_LEN_ARRAY 1)
  set(INTERNAL_ZLIB 1)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>") # statically link VC runtime library
  add_compile_options(/W4)   # set warning level 4
  add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/WX>) # treat warnings as errors
  add_compile_options(/EHsc) # set exception handling behavior
  add_compile_options(/FC)   # use full pathnames in diagnostics
  add_link_options(/STACK:0x800000)  # set stack size to 8MB (default is 1MB)
  if(CMAKE_BUILD_TYPE STREQUAL "Release")
    add_compile_options(/Oi)   # enable intrinsics
    add_compile_options(/GF)   # enable string pooling
    add_compile_options(/Zi)   # enable debugging information
    add_compile_options(/GL)   # whole program optimization
    add_link_options(/LTCG)    # link-time code generation
    add_link_options(/DEBUG)   # enable debugging information
    add_link_options(/OPT:REF) # optimize: remove unreferenced functions & data
    add_link_options(/OPT:ICF) # optimize: enable COMDAT folding
    # the combination of /Zi compiler flag and /DEBUG /OPT:REF /OPT:ICF
    # linker flags is needed to create .pdb output on release builds
  endif()
elseif(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  set(HOST_SOLARIS 1)
  add_definitions(-DGC_SOLARIS_THREADS -DGC_SOLARIS_PTHREADS -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS -DUSE_MMAP -DUSE_MUNMAP -DHOST_SOLARIS -D__EXTENSIONS__ -D_XPG4_2)
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  set(HOST_FREEBSD 1)
else()
  message(FATAL_ERROR "Host '${CMAKE_SYSTEM_NAME}' not supported.")
endif()

######################################
# TARGET OS CHECKS
######################################

if(NOT TARGET_SYSTEM_NAME)
  set(TARGET_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}")
endif()

if(TARGET_SYSTEM_NAME STREQUAL "Darwin")
  set(TARGET_MACH 1)
  set(TARGET_OSX 1)
  set(TARGET_DARWIN 1)
  if(CMAKE_SYSTEM_VARIANT STREQUAL "MacCatalyst")
    set(TARGET_MACCAT 1)
  endif()
elseif(TARGET_SYSTEM_NAME STREQUAL "iOS" OR TARGET_SYSTEM_NAME STREQUAL "tvOS")
  set(TARGET_MACH 1)
  set(TARGET_IOS 1)
  set(TARGET_DARWIN 1)
  if(TARGET_SYSTEM_NAME STREQUAL "tvOS")
    set(TARGET_TVOS 1)
  endif()
  set(TARGET_APPLE_MOBILE 1)
elseif(TARGET_SYSTEM_NAME STREQUAL "Linux")
  set(TARGET_LINUX 1)
elseif(TARGET_SYSTEM_NAME STREQUAL "Android")
  set(TARGET_ANDROID 1)
  if (CMAKE_BUILD_TYPE STREQUAL "Release")
    add_compile_options(-O2)
  endif()
elseif(TARGET_SYSTEM_NAME STREQUAL "Emscripten")
  set(TARGET_BROWSER 1)
  if (CMAKE_BUILD_TYPE STREQUAL "Release")
    add_compile_options(-Os)
  endif()
elseif(TARGET_SYSTEM_NAME STREQUAL "WASI")
  set(TARGET_WASI 1)
elseif(TARGET_SYSTEM_NAME STREQUAL "Windows")
  set(TARGET_WIN32 1)
elseif(TARGET_SYSTEM_NAME STREQUAL "SunOS")
  set(TARGET_SOLARIS 1)
elseif(TARGET_SYSTEM_NAME STREQUAL "FreeBSD")
  set(TARGET_FREEBSD 1)
else()
  message(FATAL_ERROR "Target '${TARGET_SYSTEM_NAME}' not supported.")
endif()

######################################
# HOST ARCH CHECKS
######################################

if(NOT "${CMAKE_OSX_ARCHITECTURES}" STREQUAL "")
  set(CMAKE_SYSTEM_PROCESSOR "${CMAKE_OSX_ARCHITECTURES}")
endif()

if(NOT "${MSVC_C_ARCHITECTURE_ID}" STREQUAL "")

=== src/runtime/src/mono/mono/mini/CMakeLists.txt ===
project(mini)

include(FindPython3)

include_directories(
  ${PROJECT_BINARY_DIR}/
  ${PROJECT_BINARY_DIR}/../..
  ${PROJECT_BINARY_DIR}/../../mono/eglib
  ${CMAKE_CURRENT_SOURCE_DIR}/../..
  ${PROJECT_SOURCE_DIR}/../
  ${PROJECT_SOURCE_DIR}/../eglib
  ${PROJECT_SOURCE_DIR}/../sgen)

if(HOST_DARWIN)
  set(OS_LIBS "-framework CoreFoundation" "-framework Foundation")

  if(CMAKE_SYSTEM_VARIANT STREQUAL "MacCatalyst")
    set(OS_LIBS ${OS_LIBS} "-lobjc" "-lc++")
  endif()
elseif(HOST_IOS)
set(OS_LIBS "-framework CoreFoundation" "-lobjc" "-lc++")
elseif(HOST_ANDROID)
set(OS_LIBS m dl log)
elseif(HOST_LINUX)
set(OS_LIBS pthread m dl)
elseif(HOST_WIN32)
set(OS_LIBS bcrypt.lib Mswsock.lib ws2_32.lib psapi.lib version.lib advapi32.lib winmm.lib kernel32.lib)
elseif(HOST_SOLARIS)
  set(OS_LIBS socket pthread m ${CMAKE_DL_LIBS})
elseif(HOST_FREEBSD)
  set(OS_LIBS pthread m)
endif()

#
# SUBDIRS
#
include(../eglib/CMakeLists.txt)
include(../utils/CMakeLists.txt)
include(../metadata/CMakeLists.txt)
include(../sgen/CMakeLists.txt)
include(../component/CMakeLists.txt)

if(HOST_WIN32)
  # /OPT:ICF merges idential functions breaking mono_lookup_icall_symbol ()
  add_link_options(/OPT:NOICF)
endif()

# ICU
if(HAVE_SYS_ICU AND NOT HOST_WASI)
  if(STATIC_ICU)
    set(pal_icushim_sources_base
        pal_icushim_static.c)
    add_definitions(-DSTATIC_ICU=1)
  else()
    set(pal_icushim_sources_base
        pal_icushim.c)
  endif()

  set(icu_shim_sources_base
      pal_calendarData.c
      pal_casing.c
      pal_collation.c
      pal_idna.c
      pal_locale.c
      pal_localeNumberData.c
      pal_localeStringData.c
      pal_normalization.c
      pal_timeZoneInfo.c
      entrypoints.c
      ${pal_icushim_sources_base})

  if (TARGET_DARWIN)
    set(icu_shim_sources_base
        ${icu_shim_sources_base}
        pal_locale.m)
  endif()

  addprefix(icu_shim_sources "${ICU_SHIM_PATH}" "${icu_shim_sources_base}")
  set_source_files_properties(${icu_shim_sources} PROPERTIES COMPILE_DEFINITIONS OSX_ICU_LIBRARY_PATH="${OSX_ICU_LIBRARY_PATH}")
  set_source_files_properties(${icu_shim_sources} PROPERTIES COMPILE_FLAGS "-I\"${ICU_INCLUDEDIR}\" -I\"${CLR_SRC_NATIVE_DIR}/libs/System.Globalization.Native/\" -I\"${CLR_SRC_NATIVE_DIR}/libs/Common/\" ${ICU_FLAGS}")
  if(TARGET_WIN32)
      set_source_files_properties(${icu_shim_sources} PROPERTIES LANGUAGE CXX)
  endif()
  if(ICU_LIBDIR)
    set(ICU_LDFLAGS "-L${ICU_LIBDIR}")
  endif()
endif()

#
# MINI
#

set(mini_common_sources
    mini.c
    mini-runtime.c
    seq-points.c
    seq-points.h
    ir-emit.h
    method-to-ir.c
    cfgdump.h
    cfgdump.c
    calls.c
    decompose.c
    mini.h
    optflags-def.h
    jit-icalls.h
    jit-icalls.c
    trace.c
    trace.h
    patch-info.h
    mini-ops.h
    mini-arch.h
    dominators.c
    cfold.c
    regalloc.h
    helpers.c
    liveness.c
    ssa.c
    abcremoval.c
    abcremoval.h
    local-propagation.c
    driver.c
    debug-mini.c
    linear-scan.c
    aot-compiler.h
    aot-compiler.c
    aot-runtime.c
    aot-runtime-wasm.c
    graph.c
    mini-codegen.c
    mini-exceptions.c
    mini-trampolines.c
    branch-opts.c
    mini-generic-sharing.c
    simd-methods.h
    simd-intrinsics.c
    mini-unwind.h
    unwind.c
    image-writer.h
    image-writer.c
    dwarfwriter.h
    dwarfwriter.c
    mini-gc.h
    mini-gc.c
    mini-llvm.h
    mini-llvm-cpp.h
    llvm-jit.h
    alias-analysis.c
    mini-cross-helpers.c
    arch-stubs.c
    llvm-runtime.h
    llvm-intrinsics.h
    llvm-intrinsics-types.h
    type-checking.c
    lldb.h
    lldb.c
    memory-access.c
    intrinsics.c
    mini-profiler.c
    interp-stubs.c
    aot-runtime.h
    ee.h
    mini-runtime.h
    llvmonly-runtime.h
    llvmonly-runtime.c
    monovm.h
    monovm.c)

set(debugger_sources
  debugger-agent-external.h
  debugger-agent-external.c
  )

set(amd64_sources
    mini-amd64.c
    mini-amd64.h
    exceptions-amd64.c
    tramp-amd64.c
    mini-amd64-gsharedvt.c
    mini-amd64-gsharedvt.h
    tramp-amd64-gsharedvt.c
    cpu-amd64.h)

set(x86_sources
    mini-x86.c
    mini-x86.h
    exceptions-x86.c
    tramp-x86.c
    mini-x86-gsharedvt.c
    tramp-x86-gsharedvt.c
    cpu-x86.h)

set(arm64_sources
    mini-arm64.c
    mini-arm64.h
    exceptions-arm64.c
    tramp-arm64.c
    mini-arm64-gsharedvt.c
    mini-arm64-gsharedvt.h
    tramp-arm64-gsharedvt.c
    cpu-arm64.h)

set(arm_sources
    mini-arm.c
    mini-arm.h
    exceptions-arm.c
    tramp-arm.c
    mini-arm-gsharedvt.c
    tramp-arm-gsharedvt.c
    cpu-arm.h)

set(riscv64_sources
    mini-riscv.c
    mini-riscv.h
    exceptions-riscv.c
    tramp-riscv.c
    cpu-riscv64.h)

set(s390x_sources
    mini-s390x.c
    mini-s390x.h
    exceptions-s390x.c
    tramp-s390x.c
    cpu-s390x.h)

set(wasm_sources
    mini-wasm.c
    tramp-wasm.c
    exceptions-wasm.c
    cpu-wasm.h)

set(powerpc64_sources
    mini-ppc.c
    mini-ppc.h
    exceptions-ppc.c
    tramp-ppc.c
    cpu-ppc64.h)

if(TARGET_AMD64)
set(arch_sources ${amd64_sources})
elseif(TARGET_X86)
set(arch_sources ${x86_sources})
elseif(TARGET_ARM64)
set(arch_sources ${arm64_sources})
elseif(TARGET_ARM)
set(arch_sources ${arm_sources})
elseif(TARGET_RISCV64)
set(arch_sources ${riscv64_sources})
elseif(TARGET_S390X)
set(arch_sources ${s390x_sources})
elseif(TARGET_WASM)
set(arch_sources ${wasm_sources})
elseif(TARGET_POWERPC64)
set(arch_sources ${powerpc64_sources})
endif()

set(darwin_sources
    mini-darwin.c)

set(windows_sources
    mini-windows.c
    mini-windows-tls-callback.c
    mini-windows.h
    )

set(posix_sources
    mini-posix.c)

if(HOST_DARWIN)
set(os_sources "${darwin_sources};${posix_sources}")
elseif(HOST_LINUX OR HOST_SOLARIS OR HOST_FREEBSD)
set(os_sources "${posix_sources}")
elseif(HOST_WIN32)
set(os_sources "${windows_sources}")
endif()

set(interp_sources
    interp/interp.h
    interp/interp-internals.h
    interp/interp.c
    interp/interp-intrins.h
    interp/interp-intrins.c
    interp/mintops.h
    interp/mintops.c
    interp/transform.c
    interp/tiering.h
    interp/tiering.c)
set(interp_stub_sources
    interp-stubs.c)

if(NOT DISABLE_INTERPRETER)
set(mini_interp_sources ${interp_sources})
else()
set(mini_interp_sources ${interp_stub_sources})
endif()

if(ENABLE_INTERP_LIB)
add_library(mono-ee-interp STATIC "${interp_sources}")
target_link_libraries(mono-ee-interp monoapi)
install(TARGETS mono-ee-interp LIBRARY)
if(HOST_WASM AND CMAKE_BUILD_TYPE STREQUAL "Debug")
# Always optimize the interpreter, even in Debug builds.  Unoptimized interp_exec_method and
# generate_code are so big that some browsers overflow the stack with even a few recursive
# invocations (e.g. during .cctor initialization)
target_compile_options(mono-ee-interp PRIVATE -O1)
endif()
endif()

if(ENABLE_LLVM)
set(llvm_sources
    mini-llvm.c
    mini-llvm-cpp.cpp
    llvm-jit.cpp)
else()
set(llvm_sources)
endif()

if(ENABLE_LLVM)
set(llvm_runtime_sources
    llvm-runtime.cpp)
elseif(ENABLE_LLVM_RUNTIME AND NOT HOST_WASM)
set(llvm_runtime_sources
    llvm-runtime.cpp)
else()
set(llvm_runtime_sources)
endif()

set(mini_sources "main-core.c;${mini_common_sources};${arch_sources};${os_sources};${mini_interp_sources};${llvm_sources};${debugger_sources};${llvm_runtime_sources}")

if(LLVM_INCLUDEDIR)
  include_directories(BEFORE SYSTEM "${LLVM_INCLUDEDIR}")
endif()

if(HOST_WIN32)
set(mini_sources "${mini_sources};${VERSION_FILE_RC_PATH}") # this is generated by GenerateNativeVersionFile in Arcade
elseif(NOT HOST_BROWSER)
set(mini_sources "${mini_sources};${VERSION_FILE_PATH}") # this is generated by GenerateNativeVersionFile in Arcade
endif()

if(HOST_WIN32)
set_source_files_properties(${ZLIB_SOURCES} PROPERTIES COMPILE_OPTIONS "/wd4005;/wd4127;/wd4131;/wd4244")
endif()

set(monosgen-sources "${metadata_sources};${utils_sources};${sgen_sources};${icu_shim_sources};${mini_sources};${ZLIB_SOURCES}")

add_library(monosgen-objects OBJECT "${monosgen-sources}")
target_link_libraries (monosgen-objects PRIVATE monoapi)
add_library(monosgen-static STATIC $<TARGET_OBJECTS:monosgen-objects>;$<TARGET_OBJECTS:eglib_objects>)
target_link_libraries (monosgen-static PRIVATE monoapi)
set_target_properties(monosgen-static PROPERTIES OUTPUT_NAME ${MONO_LIB_NAME})

if(DISABLE_COMPONENTS)
  # add component fallback stubs into static mono library when components have been disabled.
  target_sources(monosgen-static PRIVATE "${mono-components-stub-objects}")
endif()

if(NOT DISABLE_LIBS)
  install(TARGETS monosgen-static LIBRARY)
endif()
if(NOT DISABLE_SHARED_LIBS)
  if(HOST_WIN32)
    add_library(monosgen-shared SHARED "mini-windows-dllmain.c;${monosgen-sources}")
    target_compile_definitions(monosgen-shared PRIVATE -DMONO_DLL_EXPORT)
  else()
    add_library(monosgen-shared SHARED $<TARGET_OBJECTS:monosgen-objects>)
    target_compile_definitions(monosgen-objects PRIVATE -DMONO_DLL_EXPORT)
  endif()
  target_sources(monosgen-shared PRIVATE $<TARGET_OBJECTS:eglib_objects>)
  set_target_properties(monosgen-shared PROPERTIES OUTPUT_NAME ${MONO_SHARED_LIB_NAME})
  target_link_libraries (monosgen-shared PRIVATE monoapi)
  target_include_directories (monosgen-shared PRIVATE monoapi)
  if(TARGET_WIN32)
    # on Windows the import library for the shared mono library will have the same name as the static library,
    # to avoid a conflict we rename the import library with the .import.lib suffix
    set_target_properties(monosgen-shared PROPERTIES IMPORT_SUFFIX ".import.lib")
  endif()
  target_link_libraries(monosgen-shared PRIVATE ${OS_LIBS} ${LLVM_LIBS} ${ICU_LIBS} ${Z_LIBS})
  if(ICU_LDFLAGS)
    set_property(TARGET monosgen-shared APPEND_STRING PROPERTY LINK_FLAGS " ${ICU_LDFLAGS}")
  endif()
  if(NOT TARGET_WASM AND STATIC_ICU)
    set_property(TARGET monosgen-shared APPEND_STRING PROPERTY LINKER_LANGUAGE CXX)
  endif ()
  if(TARGET_DARWIN)
    set_property(TARGET monosgen-shared APPEND_STRING PROPERTY LINK_FLAGS " -Wl,-compatibility_version -Wl,2.0 -Wl,-current_version -Wl,2.0")
  endif()
  if(NOT DISABLE_COMPONENTS AND STATIC_COMPONENTS AND NOT DISABLE_LINK_STATIC_COMPONENTS)
    # if components are built statically, but we're building a shared lib mono,
    # link them into the library
    target_sources(monosgen-shared PRIVATE "${mono-components-objects}")
  elseif(NOT DISABLE_COMPONENTS AND STATIC_COMPONENTS AND DISABLE_LINK_STATIC_COMPONENTS)
    # if components are built statically, we're building a shared lib mono, but we shouldn't link components
    # link the fallback stubs into the runtime
    target_sources(monosgen-shared PRIVATE "${mono-components-stub-objects}")
  elseif(NOT DISABLE_COMPONENTS AND NOT STATIC_COMPONENTS)
    # if components are built dynamically, link the fallback stubs into the runtime
    target_sources(monosgen-shared PRIVATE "${mono-components-stub-objects}")
  elseif(DISABLE_COMPONENTS)
    # if components are disabled, link the fallback stubs into the runtime
    target_sources(monosgen-shared PRIVATE "${mono-components-stub-objects}")
  endif()
  install(TARGETS monosgen-shared LIBRARY)
  if(HOST_WIN32 AND TARGET_AMD64)
    add_library(monosgen-shared-dac SHARED "mini-windows-dlldac.c")
    target_link_libraries(monosgen-shared-dac monoapi)
    set_target_properties(monosgen-shared-dac PROPERTIES OUTPUT_NAME ${MONO_SHARED_LIB_NAME}-dac)
  endif()

  if(BUILD_DARWIN_FRAMEWORKS)
    if(TARGET_DARWIN)
      # In cmake, you cannot have list entries which contain a space or semicolon - those are considered
      # record separators (i.e. a list of list(APPEND foo "a" "b;c" "d e") is a five entry list of values
      # a, b, c, d and e.
      # So, in order to treat the components lists as single list entries, swap out the ; character
      # for a temporary replacement character, allowing the full lists to be treated as single entries
      string(REPLACE ";" "*" mono-components-objects-nowhitespace "${mono-components-objects}")
      string(REPLACE ";" "*" mono-components-stub-objects-nowhitespace "${mono-components-stub-objects}")

## dotnet7 7.0.105

=== debian/changelog ===
dotnet7 (7.0.105-0ubuntu2) lunar; urgency=medium

  * tests/basic-checks: updated basic version check to new dotnet version.

 -- Ian Constantin <ian.constantin@canonical.com>  Wed, 12 Apr 2023 12:03:05 +0300

dotnet7 (7.0.105-0ubuntu1) lunar; urgency=medium

  * New upstream release.
  * SECURITY UPDATE: elevation of privilege
    - CVE-2023-28260: AzureDevOps Elevation of Privilege - Dotnet CWD dll
      hijack vuln.

 -- Ian Constantin <ian.constantin@canonical.com>  Thu, 06 Apr 2023 09:52:42 +0300

dotnet7 (7.0.104-0ubuntu2) lunar; urgency=medium

  * d/p/add-kinetic-rids.patch: Added RIDs for ubuntu 22.10 kinetic.
    - Based on the dropped d/p/66225runtime-fix-runtime-id.patch 
      from wfurt <tweinfurt@yahoo.com>.

 -- Dominik Viererbe <dominik.viererbe@canonical.com>  Tue, 21 Mar 2023 19:16:20 +0200

dotnet7 (7.0.104-0ubuntu1) lunar; urgency=medium

  * New upstream microrelease.
  * d/p/66225runtime-fix-runtime-id.patch : Dropped.

 -- Miriam España Acebal <miriam.espana@canonical.com>  Fri, 10 Mar 2023 12:45:58 +0100

dotnet7 (7.0.103-0ubuntu1) lunar; urgency=medium

  * New upstream microrelease.
  * d/control: Using libicu72.
  * d/p/2671-remove-Proprietary-comment.patch: Remove comment. This is
    merged upstream but it isn't reflected on the source code yet.
  * d/repack-dotnet-tarball.sh: New file. Repack MS tarball.
  * d/rules: if-else for bootstrapping building versus normal one (LP: #2006531).
    Removing unused commented lines for clarity.

 -- Miriam España Acebal <miriam.espana@canonical.com>  Wed, 08 Feb 2023 10:15:30 +0100

dotnet7 (7.0.102-0ubuntu2) lunar; urgency=medium

  * Rebuild against latest icu

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 04 Feb 2023 10:34:33 -0500

dotnet7 (7.0.102-0ubuntu1) lunar; urgency=medium

  * New upstream microrelease.
  * d/rules: Reverting DOTNET_TOP, but still using dotnet_version
    to get previous sdk when building.
  * d/test: Improving existing DEP-8 tests.

  [Graham Inggs]
  * d/test/basic-*: Adding AUTOPKGTEST_TMP for allowing dotnet muxer
    to find correct path for execution.

 -- Miriam España Acebal <miriam.espana@canonical.com>  Thu, 19 Jan 2023 13:43:55 +0100

dotnet7 (7.0.101-0ubuntu2) lunar; urgency=medium

  * d/rules: Fixing DOTNET_TOP: still both bootstrapped archs use old layout.

 -- Miriam España Acebal <miriam.espana@canonical.com>  Wed, 18 Jan 2023 16:59:44 +0100

dotnet7 (7.0.101-0ubuntu1) lunar; urgency=medium

  * New upstream microrelease.
  * d/rules: adapting DOTNET_TOP for amd64 when still uses
    MS bootstrapped debs on building. Erasing switch comments 
    for building depending on layout.
  * d/dotnet-host-7.0.manpages: Renamed from
    d/dotnet-sdk-7.0.manpages. Attaching man pages installation
    here to avoid conflicts when two different SDKs are installed.
  * d/control: Added Breaks field for avoid installation issues when dotnet6
    (previous versions to 6.0.111) is on the system.

  [Steve Langasek]
  * Refresh debian/patches/66225runtime-fix-runtime-id.patch for lunar.

 -- Miriam España Acebal <miriam.espana@canonical.com>  Fri, 16 Dec 2022 11:45:51 +0100

dotnet7 (7.0.100-0ubuntu1) lunar; urgency=medium

  * Initial release (LP: #1995478).

 -- Miriam España Acebal <miriam.espana@canonical.com>  Wed, 07 Dec 2022 18:49:39 +0000

=== debian/control ===
Source: dotnet7
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: clang,
               cmake,
               bash-completion,
               debhelper-compat (= 13),
               dotnet-sdk-7.0,
               dotnet-sdk-7.0-source-built-artifacts,
               git,
               libicu-dev,
               libkrb5-dev,
               liblttng-ust-dev,
               libssl-dev,
               libunwind-dev,
               lld,
               llvm,
               locales-all,
               python3,
               zlib1g-dev
Standards-Version: 4.7.0
Rules-Requires-Root: binary-targets
Homepage: https://dot.net/core

Package: dotnet7
Architecture: amd64 arm64
Depends: dotnet-sdk-7.0, ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet6 (<< 6.0.111~)
Description: dotNET CLI tools and runtime
 dotNET is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications and micro-services.
 .
 dotNET contains a runtime conforming to dotNET Standards a set of
 framework libraries, an SDK containing compilers and a 'dotnet'
 application to drive everything.

Package: dotnet-host-7.0
Architecture: amd64 arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: dotnet-host
Replaces: dotnet-host
Provides: dotnet-host
Description: dotNET host command line
 The dotNET host is a command line program that runs a standalone
 dotNET application or launches the SDK.
 .
 dotNET is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications and micro-services.

Package: dotnet-hostfxr-7.0
Architecture: amd64 arm64
Depends: dotnet-host-7.0, ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-hostfxr-6.0 (<< 6.0.111~)
Description: dotNET host resolver
 The dotNET host resolver contains the logic to resolve and select
 the right version of the dotNet SDK or runtime to use.
 .
 dotNET is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications and micro-services.

Package: dotnet-runtime-7.0
Architecture: amd64 arm64
Depends: dotnet-hostfxr-7.0,
         libicu72,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: dotnet-runtime-6.0 (<< 6.0.111~)
Description: dotNET runtime
 The dotNET runtime contains everything needed to run dotNet applications.
 It includes a high performance Virtual Machine as well as the framework
 libraries used by dotNet applications.
 .
 dotNET is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications and micro-services.

Package: aspnetcore-runtime-7.0
Architecture: amd64 arm64
Depends: dotnet-runtime-7.0, ${misc:Depends}, ${shlibs:Depends}
Breaks: aspnetcore-runtime-6.0 (<< 6.0.111~)
Description: ASP dotNET Core runtime
 The ASP dotNET Core runtime contains everything needed to run dotNet
 web applications. It includes a high performance Virtual Machine as
 well as the framework libraries used by dotNet applications.
 .
 ASP dotNET Core is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications and micro-services.

Package: dotnet-templates-7.0
Architecture: amd64 arm64
Depends: dotnet-host-7.0, ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-templates-6.0 (<< 6.0.111~)
Description: dotNET 7.0 templates
 This package contains templates used by the dotNet SDK.
 .
 dotNET is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications and micro-services.

Package: dotnet-sdk-7.0
Architecture: amd64 arm64
Depends: aspnetcore-runtime-7.0,
         aspnetcore-targeting-pack-7.0,
         dotnet-apphost-pack-7.0,
         dotnet-runtime-7.0,
         dotnet-targeting-pack-7.0,
         dotnet-templates-7.0,
         netstandard-targeting-pack-2.1-7.0,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: dotnet-sdk-6.0 (<< 6.0.111~)
Description: dotNET 7.0 Software Development Kit
 The dotNET SDK is a collection of command line applications to
 create, build, publish and run dotNet applications.
 .
 dotNET is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications and micro-services.

Package: dotnet-sdk-7.0-source-built-artifacts
Architecture: amd64 arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Internal package for building dotNet 7.0 Software Development Kit
 The dotNET source-built archive is a collection of packages needed
 to build the dotNET SDK itself.
 .
 These are not meant for general use.

Package: dotnet-targeting-pack-7.0
Architecture: amd64 arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-targeting-pack-6.0 (<< 6.0.111~)
Description: Internal - targeting pack for Microsoft.NETCore.App 7.0
 This package provides a targeting pack for Microsoft.NETCore.App 7.0
 that allows developers to compile against and target Microsoft.NETCore.App 7.0
 applications using the .NET SDK. This are not meant for general use.

Package: netstandard-targeting-pack-2.1-7.0
Architecture: amd64 arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: netstandard-targeting-pack-2.1
Replaces: netstandard-targeting-pack-2.1
Provides: netstandard-targeting-pack-2.1
Description: Internal - targeting pack for NETStandard.Library 2.1
 This package provides a targeting pack for NETStandard.Library 2.1
 that allows developers to compile against and target NETStandard.Library 2.1
 applications using the .NET SDK.
 This are not meant for general use.

Package: aspnetcore-targeting-pack-7.0
Architecture: amd64 arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: aspnetcore-targeting-pack-6.0 (<< 6.0.111~)
Description: Internal - targeting pack for Microsoft.AspNetCore.App 7.0
 This package provides a targeting pack for Microsoft.AspNetCore.App 7.0
 that allows developers to compile against and target
 Microsoft.AspNetCore.App 7.0 applications using the .NET SDK.
 This are not meant for general use.

Package: dotnet-apphost-pack-7.0
Architecture: amd64 arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-apphost-pack-6.0 (<< 6.0.111~)
Description: Internal - targeting pack for Microsoft.NETCore.App 7.0
 This package provides a targeting pack for Microsoft.NETCore.App 7.0
 that allows developers to compile against and target Microsoft.NETCore.App 7.0
 applications using the .NET SDK. This not meant for general use.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

SHELL = /bin/bash
export HOME=$(shell mktemp -d)

ifeq ($(DEB_HOST_ARCH), amd64)
        _RUNTIME_ARCH = x64
else ifeq ($(DEB_HOST_ARCH), arm64)
        _RUNTIME_ARCH = arm64
endif

_RUNTIME_ID = $(shell . /etc/os-release; [ ! -z $${VERSION_ID} ] && echo $${ID}.$${VERSION_ID} || echo $${ID})
_SDK_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | cut -d'-' -f1)
_minor_sdk_version=$(shell echo $(_SDK_VERSION) | sed 's/.*\(.\)/\1/')
_RUNTIME_VERSION = 7.0.$(_minor_sdk_version)
_VERSION = $(shell echo $(_SDK_VERSION) | cut -d'.' -f1)

PREFIX = /usr
SYSCONFDIR = /etc
BINDIR = $(PREFIX)/bin
LIBDIR = $(PREFIX)/lib
DATADIR = $(PREFIX)/share
MANDIR = $(DATADIR)/man
DESTDIR = $(CURDIR)/debian/tmp
DOTNET_TOP = $(LIBDIR)/dotnet
dotnet_version = dotnet$(_VERSION)
dotnet_dirname = $(dotnet_version)-$(_SDK_VERSION)
DOTNETLIBDIR=$(DOTNET_TOP)
DOTNETETCDIR=$(SYSCONFDIR)/dotnet

INITIAL_BOOTSTRAPPING=1

%:
	dh $@ --with bash-completion

override_dh_auto_build:

ifeq ($(INITIAL_BOOTSTRAPPING),1)
	mkdir -p $(CURDIR)/packages/archive
	ln -s $(DOTNET_TOP)/source-built-artifacts/Private.SourceBuilt.Artifacts.*.tar.gz $(CURDIR)/packages/archive/
	cp -RLp $(DOTNET_TOP) $(CURDIR)/previously-built-dotnet
	find previously-built-dotnet

	VERBOSE=1 ./build.sh \
	--with-sdk $(CURDIR)/previously-built-dotnet \
	-- \
	/v:n \
	/p:SkipPortableRuntimeBuild=true \
	/p:LogVerbosity=n \
	/p:MinimalConsoleLogOutput=false \
   	/p:ContinueOnPrebuiltBaselineError=true
else
	VERBOSE=1 ./build.sh --clean-while-building \
	-- \
	/v:n \
	/p:SkipPortableRuntimeBuild=true \
	/p:LogVerbosity=n \
	/p:MinimalConsoleLogOutput=false \
	/p:ContinueOnPrebuiltBaselineError=true
endif

override_dh_install:

	install -dm 0755 $(DESTDIR)/$(DOTNETLIBDIR)
	install -dm 0755 $(DESTDIR)/$(DOTNETETCDIR)
	ls artifacts/$(_RUNTIME_ARCH)/Release
	tar xf artifacts/$(_RUNTIME_ARCH)/Release/dotnet-sdk-*-$(_RUNTIME_ID)-$(_RUNTIME_ARCH).tar.gz -C $(DESTDIR)/$(DOTNETLIBDIR)

	# See https://github.com/dotnet/source-build/issues/2579
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name 'testhost.x86' -delete
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name 'vstest.console' -delete


	# Fix executable permissions on files
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name 'apphost' -exec chmod +x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name 'lib*so' -exec chmod +x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name 'singlefilehost' -exec chmod +x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.a' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.dll' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.h' -exec chmod 0644 {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.json' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.pdb' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.props' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.pubxml' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.targets' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.txt' -exec chmod -x {} \;
	find $(DESTDIR)/$(DOTNETLIBDIR) -type f -name '*.xml' -exec chmod -x {} \;


	echo "$(DOTNETLIBDIR)" > install_location_$(_RUNTIME_ARCH)

	for f in debian/*.in; do \
	  f2=$$(echo $$f | sed 's/\.in$$//'); \
	  sed -e 's,@DOTNET_TOP@,$(DOTNET_TOP),g' \
	      -e 's,@basedir@,$(DOTNETLIBDIR),g' \
	      -e 's,@dotnet_dirname@,$(dotnet_dirname),g' \
	      -e 's,@major@,$(_VERSION),g' \
    	  -e 's,@dotnet_version@,$(dotnet_version),g' \
	      -e 's,@rid@,$(_RUNTIME_ID),g' \
	      -e 's,@arch@,$(_RUNTIME_ARCH),g' \
	      -e 's,@etcdir@,$(DOTNETETCDIR),g' \
	      -e 's,@multiarch@,$(DEB_HOST_MULTIARCH),g' \
	      -e 's,@hostarch@,$(DEB_HOST_ARCH),g' \
	      -e 's,@runtimearch@,$(_RUNTIME_ARCH),g' \
	    $$f > $$f2; \
	done

	cp $(CURDIR)/debian/install_location $(CURDIR)/debian/install_location_$(_RUNTIME_ARCH)
	dh_install

override_dh_dwz:
#	Leaving it empty due to "dwz: Unknown debugging section .debug_addr"

=== debian/tests/control ===
Tests: basic-checks
Depends: @
Restrictions: superficial

Tests: basic-commands
Depends: @

=== debian/watch ===
version=4
#opts="mode=git,repack,compression=xz,filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%dotnet-$1.tar.gz%" \
#https://github.com/mirespace/dotnet6 \
#refs/tags/v(\d[\d.]*) 
opts="repack,compression=xz,filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%dotnet-$1.tar.gz%" \
  https://github.com/dotnet/installer/tags \
  (?:.*?/)?v(\d[\d.]*)\.tar\.gz \
  debian debian/build-dotnet-tarball.sh <target_repo>

## dotnet7 7.0.109

=== debian/changelog ===
dotnet7 (7.0.109-0ubuntu1~22.10.1) kinetic-security; urgency=medium

  * New upstream release.
  * SECURITY UPDATE: security feature bypass
    - CVE-2023-33170: Race Condition in ASP.NET Core SignInManager<TUser>
      PasswordSignInAsync Method.
  * debian/tests: introduced missing .tests.rc.d directory.
  * debian/tests/control: enabled test dotnet-runtime-json-contains-ubuntu-rids.
  * debian/tests/.tests.rc.d/init.sh: fixed parsing error of runtime revision
    number.

 -- Ian Constantin <ian.constantin@canonical.com>  Thu, 06 Jul 2023 10:59:12 +0300

dotnet7 (7.0.108-0ubuntu1~22.10.1) kinetic-security; urgency=medium

  [ Mateus Rodrigues de Morais ]
  * New upstream release.
    - Fixes regression that was introduced with the bugfix for CVE-2023-29331:
      Loading null-password-encrypted PFX certificates through .NET can fail
      unexpectedly for certificates that previously loaded successfully.
  [ Ian Constantin ]
  * debian/tests: introducing extended autopkgtests accidentally missed in the
    previous release.

 -- Ian Constantin <ian.constantin@canonical.com>  Wed, 21 Jun 2023 16:12:30 +0300

dotnet7 (7.0.107-0ubuntu1~22.10.1) kinetic-security; urgency=medium

  * New upstream release.
  * SECURITY UPDATE: elevation of privilege
    - CVE-2023-24936: Bypass restrictions when deserializing a DataSet or
      DataTable from XML.
  * SECURITY UPDATE: denial of service
    - CVE-2023-29331: When a .NET application is internet-facing and accepts
      an X509 client certificate for mutual TLS, a malicious client certificate
      can cause unbounded CPU usage.
  * SECURITY UPDATE: remote code exection
    - CVE-2023-29337: A vulnerability exists in NuGet where a potential race
      condition can lead to a symlink attack.
  * SECURITY UPDATE: elevation of privilege
    - CVE-2023-32032: TarFile.ExtractToDirectory ignores extraction directory
      argument.
  * SECURITY UPDATE: remote code execution
    - CVE-2023-33128: An issue in source generators can lead to a crash due to
      unmanaged heap corruption.
  * debian/patches/add-kinetic-rids.patch: removed due to inclusion upstream.

  [ Dominik Viererbe ]
  * d/t: extended autopkgtest:
    * essential-binaries-and-config-files-should-be-present
    * cli-metadata-should-be-correct
    * global-json-should-be-detected
    * console-template-should-build-and-run
    * dotnet-help-should-show-output
    * dotnet-project-management-cli-should-work
    * example-fsharp-script-output-should-equal-expected-values
    * building-hello-world-for-all-supported-rids-should-work
    * dotnet-xunit-tests-should-work
    * nuget-cli-should-be-able-to-consume-packages-from-nuget-gallery
    * crossbuild-for-windows-x64-should-run
    * dotnet6-and-dotnet7-should-work-together

 -- Ian Constantin <ian.constantin@canonical.com>  Fri, 02 Jun 2023 22:28:04 +0300

dotnet7 (7.0.105-0ubuntu1~22.10.1) kinetic-security; urgency=medium

  * New upstream release.
  * SECURITY UPDATE: elevation of privilege
    - CVE-2023-28260: AzureDevOps Elevation of Privilege - Dotnet CWD dll
      hijack vuln.

 -- Ian Constantin <ian.constantin@canonical.com>  Thu, 06 Apr 2023 10:24:09 +0300

dotnet7 (7.0.104-0ubuntu2~22.10.1) kinetic; urgency=medium

  * Backport dotnet 7.0.104 to kinetic (LP: #2011809).
    - debian/control: revert to libicu71

 -- Dominik Viererbe <dominik.viererbe@canonical.com>  Wed, 22 Mar 2023 13:14:34 +0200

=== debian/control ===
--- 
+++ 
@@ -71,7 +71,7 @@
 Package: dotnet-runtime-7.0
 Architecture: amd64 arm64
 Depends: dotnet-hostfxr-7.0,
-         libicu72,
+         libicu71,
          ${misc:Depends},
          ${shlibs:Depends}
 Breaks: dotnet-runtime-6.0 (<< 6.0.111~)

=== debian/tests/control ===
Tests: 
 essential-binaries-and-config-files-should-be-present
Depends: dotnet7
Restrictions: superficial

Tests:
 cli-metadata-should-be-correct
Depends: dotnet7
Restrictions: skippable

Tests:
 global-json-should-be-detected,
 console-template-should-build-and-run,
 dotnet-help-should-show-output,
 dotnet-project-management-cli-should-work,
 example-fsharp-script-output-should-equal-expected-values,
 building-hello-world-for-all-supported-rids-should-work,
 dotnet-runtime-json-contains-ubuntu-rids
Depends: dotnet7

Tests: 
 dotnet-xunit-tests-should-work,
 nuget-cli-should-be-able-to-consume-packages-from-nuget-gallery
Depends: dotnet7
Restrictions: needs-internet

Tests: 
 crossbuild-for-windows-x64-should-run
Depends: dotnet7, wine
Architecture: amd64

Tests:
 dotnet6-and-dotnet7-should-work-together
Depends: dotnet6, dotnet7
